﻿using System;
using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.EvolutionaryTracking {
  [StorableClass]
  public class LineageExplorer : Item {
    [Storable]
    private ISymbolicExpressionTreeGenealogyGraph genealogyGraph;
    public ISymbolicExpressionTreeGenealogyGraph GenealogyGraph { get { return genealogyGraph; } set { genealogyGraph = value; } }
    [Storable]
    private IList<Tuple<ISymbolicExpressionTree, double>> trees;
    public IList<Tuple<ISymbolicExpressionTree, double>> Trees { get { return trees; } set { trees = value; } }
    [Storable]
    private int generations;
    public int Generations { get { return generations; } set { generations = value; } }

    private LineageExplorer(bool deserializing) : base(deserializing) { }
    private LineageExplorer(LineageExplorer original, Cloner cloner)
      : base(original, cloner) {
      genealogyGraph = original.genealogyGraph;
      trees = original.trees;
      generations = original.generations;
    }
    public LineageExplorer() { }
    public override IDeepCloneable Clone(Cloner cloner) { return new LineageExplorer(this, cloner); }
  }
}
